type url = Filename of string | Url of string

let start_with s p =
  let l = String.length p in
  let n = String.length s in
  if (n >= l) && (String.sub s 0 l = p)
  then Some (String.sub s l (n - l))
  else None

let is_url s = 
  try let _ = Neturl.extract_url_scheme s in true
  with Neturl.Malformed_URL -> false
	
let no_load_url s =
  let msg =  
    Printf.sprintf 
      "Error \"%s\": \nTo fetch external URLs, you need to compile CDuce with curl and/or netclient" s 
  in
  raise (Location.Generic msg) 

let load_url = ref no_load_url

let process s =
  match start_with s "string://" with
    | None -> 
	if is_url s then Url (!load_url s)
	else Filename s
    | Some s ->
	Url s
